
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <windows.h>
// shell32.lib
#include <shellapi.h>

//  Include files
#include <uf.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_cfi.h>
#include <uf_part.h>

#include "dlg_menu.h"

/**********************************************************************/

#define BUF 128

#define UF_CALL(X) (report( __FILE__, __LINE__, #X, (X)))

char filename[132];
static const char szFileDat[] = ".pog";
    char         *grip_exe = "opu_Pogo_activator.grx";
    char         *winword = "opu_Pogo_activator_user_instruction.doc\0";

/**********************************************************************/

int dlg_menu_ui_run ( void )
{
 int i , ready;
 char *path , envpath[255] , dllpath[255] , msg[133];

 char env_names[][25]={
  	"UGII_USER_DIR" ,
  	"UGII_SITE_DIR" ,
  	"UGII_VENDOR_DIR" ,
  	"UGII_GROUP_DIR" ,
  	"USER_UFUN" ,
  	"UGII_INITIAL_UFUN_DIR" ,
  	"UGII_INITIAL_GRIP_DIR" ,
  	"UGII_TMP_DIR" ,
  	"HOME" ,
  	"TMP" } ;

    double       user_response = 0;
    int          status = -1;
    int          grip_arg_count = 0;
    UF_args_t    grip_arg_list[1];

  /* Define the argument list for UG/Open API calling GRIP */
    grip_arg_list[0].type    = UF_TYPE_DOUBLE;
    grip_arg_list[0].length  = 0;
    grip_arg_list[0].address = &user_response;

 path = (char *) malloc(255+10);

 ready=-1;
  for (i=0;i<10;i++) {
    dllpath[0]='\0';
    envpath[0]='\0';
    path=envpath;
    UF_translate_variable(env_names[i], &path);
    if (path!=NULL) {
       strcpy(dllpath,path);
       strcat(dllpath,"\\application\\");
       strcat(dllpath,grip_exe);
       UF_print_syslog(dllpath,FALSE);
       //   
       UF_CFI_ask_file_exist (dllpath, &status );
       if (!status) { ready=1; break ; }
     } //if (envpath!=NULL) {
  } // for

 if (ready==-1) {
    msg[0]='\0'; sprintf (msg," %s -   \n ...",grip_exe);
    uc1601 (msg, TRUE );
    return (-1);
 }

 /* Execute the GRIP program */
 status = UF_CALL(UF_call_grip (dllpath, grip_arg_count, grip_arg_list));

 if ( (status == 0) && (user_response >= 3) )
 {

  }

  return (0);
}


/*======================================================================*/
static int report( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char    messg[133];
        printf("%s, line %d:  %s\n", file, line, call);
        (UF_get_fail_message(irc, messg)) ?
            printf("    returned a %d\n", irc) :
            printf("    returned error %d:  %s\n", irc, messg);
    }
    return(irc);
}


/*======================================================================*/
int dlg_menu_ui_mgr(void)
{
  int response ;
  char menu_main[14][38];

  if (NULL_TAG == UF_PART_ask_display_part ())
  {
     UF_UI_display_nonmodal_msg ("  :", "       ." , UF_UI_MSG_POS_TOP_LEFT );
  }
  /* Continue execution if the part tag is valid. */

  strcpy(&menu_main[0][0], "->   POGO\0");
  strcpy(&menu_main[1][0], "->  .\0");

  response=3;
  while (response != 1 && response != 2  && response != 19 )
  {

   response = uc1603(" .....",1,menu_main, 1+1);

   if (response >= 3 || response < 19 )
   {
     switch (response)
     {
        case 5 ://   
        dlg_menu_ui_run();
        break ;
        case 6 ://    help
        dlg_menu_ui_help();
        break ;
        default : break ;
      }
   }

  } // end while uc1603

 return(0);
}


/*======================================================================*/
int dlg_menu_ui_file(void)
{

   char filter_string[132] = "*.pog";
   int response = 0;
   int rc = 0;
   char msg[132];

   rc = UF_UI_create_filebox ("   ..",
                              "   ..",
                              filter_string,
                              (char *)szFileDat,
                              filename,
                              &response);
   if(rc)
   {
        /* Print out the message */
        UF_get_fail_message(rc, msg);
        UF_UI_set_status( msg );
        UF_print_syslog(msg,FALSE);
        response = -rc*rc ;
   }

   return(response);
}


/*======================================================================*/
int dlg_menu_ui_help(void)
{
  int response;
  char menu[1][38];
  char mes[256] ;

 int i , ready;
 char *path , envpath[255] , dllpath[255];

 char env_names[][25]={
  	"UGII_USER_DIR" ,
  	"UGII_SITE_DIR" ,
  	"UGII_VENDOR_DIR" ,
  	"UGII_GROUP_DIR" ,
  	"USER_UFUN" ,
  	"UGII_INITIAL_UFUN_DIR" ,
  	"UGII_INITIAL_GRIP_DIR" ,
  	"UGII_TMP_DIR" ,
  	"HOME" ,
  	"TMP" } ;

    int          status = -1;

 path = (char *) malloc(255+10);

 ready=-1;
  for (i=0;i<10;i++) {

    envpath[0]='\0';
    path=envpath;
    UF_translate_variable(env_names[i], &path);

    dllpath[0]='\0';
    if (path!=NULL) {
       strcpy(dllpath,path);
       strcat(dllpath,"\\application\\");
       strcat(dllpath,winword);
       UF_print_syslog(dllpath,FALSE);
       //   
       UF_CFI_ask_file_exist (dllpath, &status );
       if (status==0) { ready=1; break ; }
     } //if (envpath!=NULL)

    dllpath[0]='\0';
    if (path!=NULL) {
       strcpy(dllpath,path);
       strcat(dllpath,"\\");
       strcat(dllpath,winword);
       UF_print_syslog(dllpath,FALSE);
       //   
       UF_CFI_ask_file_exist (dllpath, &status );
       if (status==0) { ready=1; break ; }
     } //if (envpath!=NULL)

  } // for

  if (ready==1) {
      try                   // Defines try block in which
      {                     // exceptions may be thrown
    	  ShellExecute( NULL, "open" ,"winword",dllpath,NULL,SW_SHOW );
    	  return (0);
      }
      // start of catch block to catch exceptions of type char*
      catch(...) //
      {                      //
        mes[0]='\0'; sprintf (mes," %s -   \n ...",winword);
        UF_UI_display_nonmodal_msg (" ...", mes , UF_UI_MSG_POS_TOP_LEFT );
      }
  }


  /*========================================================================================*/

  UF_UI_open_listing_window();

  UF_UI_write_listing_window("\n     .");

  UF_UI_write_listing_window("\n#============================================================");
  UF_UI_write_listing_window("\n : \t (       ...: )");
  UF_UI_write_listing_window("\n\t ");
  UF_UI_write_listing_window("\n\t ");
  UF_UI_write_listing_window("\n#============================================================");

  mes[0]='\0'; sprintf(mes,"\n   (Grip)   : %s ",grip_exe); UF_UI_write_listing_window(mes);
  mes[0]='\0'; sprintf(mes,"\n  : %s ",winword); UF_UI_write_listing_window(mes);
  mes[0]='\0'; sprintf(mes,"\n   (*.pog)        : %s ",filename); UF_UI_write_listing_window(mes);

  UF_UI_write_listing_window("\n#============================================================");

UF_UI_write_listing_window("\n");
UF_UI_write_listing_window("\n\t   :");
UF_UI_write_listing_window("\n\n0.    \"  POGO\" -   GRIP .");

UF_UI_write_listing_window("\n             : (File ->  UG/Open -> GRIP..   Ctrl+G),");
mes[0]='\0';   sprintf(mes,"\n            :       %s    ",grip_exe); UF_UI_write_listing_window(mes);

UF_UI_write_listing_window("\n --------------------------------------------------------------------------- ");

UF_UI_write_listing_window("\n\n1.     ,      ");
UF_UI_write_listing_window("\n     , ,        . ");

UF_UI_write_listing_window("\n\n2.        (  WAVE ? ),    ");
UF_UI_write_listing_window("\n      POGO.         . ");

UF_UI_write_listing_window("\n\n3.      ,     . ");
UF_UI_write_listing_window("\n             OK.");

UF_UI_write_listing_window("\n\n4.        (FIXED  SLIDER). ");
UF_UI_write_listing_window("\n          ,    .");

UF_UI_write_listing_window("\n\n5.         POGO    ,");
UF_UI_write_listing_window("\n               (R=76.2   R=152.4 ),");
UF_UI_write_listing_window("\n    ,    ,      .");
UF_UI_write_listing_window("\n         ,     .");
UF_UI_write_listing_window("\n          .");

UF_UI_write_listing_window("\n\n6.          ");
UF_UI_write_listing_window("\n         ,   POGO   .");

UF_UI_write_listing_window("\n\n        ::");
UF_UI_write_listing_window("\n        Z   .");
UF_UI_write_listing_window("\n           XY.");
UF_UI_write_listing_window("\n           . ......");
UF_UI_write_listing_window("\n           POGO   45,");
UF_UI_write_listing_window("\n          .");
UF_UI_write_listing_window("\n        ,   ");
UF_UI_write_listing_window("\n       ");
UF_UI_write_listing_window("\n    (:  D:\\Pogo_program\\obshivka0364.pog)");

UF_UI_write_listing_window("\n\n#============================================================\n$$");

  strcpy(&menu[0][0], "\0");

  response=3;
  while (response == 3 || response == 4) {
    response = uc1603("      ..",0,menu, 0+1);
  }

  //UF_UI_close_listing_window () ;

  return(0);

}

